<?php
namespace Mirasvit\Sorting\Controller\Track\ProductImpression;

/**
 * Interceptor class for @see \Mirasvit\Sorting\Controller\Track\ProductImpression
 */
class Interceptor extends \Mirasvit\Sorting\Controller\Track\ProductImpression implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Magento\Framework\App\Action\Context $context, \Magento\Store\Model\StoreManagerInterface $storeManager, \Magento\Reports\Model\Product\Index\ViewedFactory $viewedFactory)
    {
        $this->___init();
        parent::__construct($context, $storeManager, $viewedFactory);
    }

    /**
     * {@inheritdoc}
     */
    public function execute()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'execute');
        return $pluginInfo ? $this->___callPlugins('execute', func_get_args(), $pluginInfo) : parent::execute();
    }

    /**
     * {@inheritdoc}
     */
    public function dispatch(\Magento\Framework\App\RequestInterface $request)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'dispatch');
        return $pluginInfo ? $this->___callPlugins('dispatch', func_get_args(), $pluginInfo) : parent::dispatch($request);
    }
}
